﻿Imports System.ComponentModel
Imports System.Text
Imports Goldammer

Namespace Online_DigtalFilter
	Partial Public Class Form1
		Inherits Form
		Public Sub New()
			InitializeComponent()
		End Sub

		Private m_firstDev As MAIDevice = Nothing
		Private m_bMeasurement As Boolean = False

		Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
            m_firstDev = Goldammer.MAI.Devices(0)
			If m_firstDev Is Nothing Then
				MessageBox.Show("No Card found.")
				Close()
			End If
			If Not m_firstDev.HasSoftwareExtension(SWExtension.Online_Filter) Then
				MessageBox.Show("This Card does not support Digital Filter Functions.")
				Close()
			End If
			AddHandler m_firstDev.ADChannels.ProcessDataBuffers, AddressOf ADChannels_ProcessDataBuffers
		End Sub

		Private Sub ADChannels_ProcessDataBuffers(ByVal obj As Object, ByVal args As EventArgs)
			Try
				SetTextboxText("")

				Dim NofValues As UInteger = m_firstDev.ADChannels.GetNumberOfValues()
				Dim Values() As Double = Nothing
				For Each c As MAIMeasurementChannelAD In m_firstDev.ADChannels.GetMeasurementChannels()
					Values = c.ReadData(NofValues)
				Next c
				If Values Is Nothing Then
					Return
				End If
				Dim textboxtxt As String = ""
				For i As Integer = 0 To 9
					If i >= Values.Length Then
						Return
					End If
					textboxtxt &= Values(i).ToString() & Environment.NewLine
				Next i
				SetTextboxText(textboxtxt)

			Catch ex As Exception
				MessageBox.Show(ex.Message)
			End Try
		End Sub

		Private Sub SetTextboxText(ByVal AITextboxText As String)
			If InvokeRequired Then ' muss den Main-Thread "invoken", der Aufruf passiert ja aus dem Notification Thread heraus.
				Dim invoker As New MethodInvoker(Function() AnonymousMethod1(AITextboxText))
				Invoke(invoker)
			Else
				textBox1.Text = AITextboxText
			End If
		End Sub
		
		Private Function AnonymousMethod1(ByVal AITextboxText As String) As Object
			textBox1.Text = AITextboxText
			Return Nothing
		End Function


		Private Sub button1_Click(ByVal sender As Object, ByVal e As EventArgs) Handles button1.Click
			If m_firstDev Is Nothing Then
				Return
			End If
			m_firstDev.ADChannels.StopMeasurement()
			m_firstDev.ADChannels.StopNotificationThread()
			m_firstDev.ClearAllChannelLists()

			If Not m_bMeasurement Then
				Dim channel As MAIMeasurementChannelAD = m_firstDev.ADChannels(0).CreateMeasurementChannel(OversamplingMode.Disabled, GainFactor.Disabled, True)
				If radioButtonFIR.Checked Then
                    channel.Realtime.AddFIRFilter(FilterType.LOWPASS, 1000, 20.3, 0, False, 15, Goldammer.FIRWindow.Rectangular, 0, True)
				ElseIf radioButtonIIR.Checked Then
					channel.Realtime.AddIIRFilter(FilterType.LOWPASS, 1000, 20.3, 0, False, 0.9, 0.1, IIRFilterDesign.BUTTERWORTH, 5)
				End If

				m_firstDev.ADChannels.SetSampleRate(1000)
				m_firstDev.ADChannels.SetMeasurementBufferNotificationLevel(100)
				m_firstDev.ConfigMeasure()
				m_firstDev.ADChannels.StartNotificationThread()
				m_firstDev.ADChannels.StartMeasurement()
				m_bMeasurement = True
				button1.Text = "Stop"
			Else
				m_bMeasurement = False
				button1.Text = "Start"

			End If


		End Sub
	End Class
End Namespace
