﻿Imports System.ComponentModel
Imports System.Text
Imports Goldammer
Namespace Online_FFT
	Partial Public Class Form1
		Inherits Form
		Public Sub New()
			InitializeComponent()
		End Sub

		Private m_firstDev As MAIDevice = Nothing
		Private m_lastUpdate As Date = Date.Now
		Private m_FFTSpec(4095) As Double
		Private m_bMeasurement As Boolean = False

		Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
			m_firstDev = Goldammer.MAI.Devices(0)
			If m_firstDev Is Nothing Then
				MessageBox.Show("No Card found.")
				Close()
			End If
			If Not m_firstDev.HasSoftwareExtension(SWExtension.Online_FFT) Then
				MessageBox.Show("This Card does not support FFT Analyzer.")
				Close()
			End If

			AddHandler m_firstDev.ADChannels.ProcessDataBuffers, AddressOf ADChannels_ProcessDataBuffers
		End Sub

		Private Sub ADChannels_ProcessDataBuffers(ByVal obj As Object, ByVal args As EventArgs)
			Try

				Dim NofValues As UInteger = m_firstDev.ADChannels.GetNumberOfValues()
				Dim Values() As Double = Nothing
				Dim fftPoints As UInteger = 4096
				For Each c As MAIMeasurementChannelAD In m_firstDev.ADChannels.GetMeasurementChannels()
					Values = c.ReadData(NofValues)
					c.ReadData_RealTime_FFT(m_FFTSpec, fftPoints)
				Next c
				If Values Is Nothing Then
					Return
				End If
				If (Date.Now.Subtract(m_lastUpdate)).TotalSeconds < 2 Then
					Return
				End If

				SetTextboxText("")
				m_lastUpdate = Date.Now
				Dim textboxtxt As String = ""
				For i As Integer = 0 To fftPoints - 1
					textboxtxt &= "[" & i.ToString() & "]" & vbTab & m_FFTSpec(i).ToString() & Environment.NewLine
				Next i
				SetTextboxText(textboxtxt)

			Catch ex As Exception
				MessageBox.Show(ex.Message)
			End Try
		End Sub

		Private Sub SetTextboxText(ByVal AITextboxText As String)
			If InvokeRequired Then ' muss den Main-Thread "invoken", der Aufruf passiert ja aus dem Notification Thread heraus.
				Dim invoker As New MethodInvoker(Function() AnonymousMethod1(AITextboxText))
				Invoke(invoker)
			Else
				textBox1.Text = AITextboxText
			End If
		End Sub
		
		Private Function AnonymousMethod1(ByVal AITextboxText As String) As Object
			textBox1.Text = AITextboxText
			Return Nothing
		End Function

		Private Sub button1_Click(ByVal sender As Object, ByVal e As EventArgs) Handles button1.Click
			If m_firstDev Is Nothing Then
				Return
			End If
			m_firstDev.ADChannels.StopMeasurement()
			m_firstDev.ADChannels.StopNotificationThread()
			m_firstDev.ClearAllChannelLists()

			If Not m_bMeasurement Then
				Dim channel As MAIMeasurementChannelAD = m_firstDev.ADChannels(0).CreateMeasurementChannel(OversamplingMode.Disabled, GainFactor.Disabled, True)

                channel.Realtime.AddFFTAnalyzer(FFTPoints._2048, FFTSpektrum.Betrag, 0.05, Goldammer.FIRWindow.Rectangular, 0)

				m_firstDev.ADChannels.SetSampleRate(1000)
				m_firstDev.ADChannels.SetMeasurementBufferNotificationLevel(100)
				m_firstDev.ConfigMeasure()
				m_firstDev.ADChannels.StartNotificationThread()
				m_firstDev.ADChannels.StartMeasurement()
				m_bMeasurement = True
				button1.Text = "Stop"
			Else
				m_bMeasurement = False
				button1.Text = "Start"

			End If


		End Sub
	End Class
End Namespace
