﻿Imports System.ComponentModel
Imports System.Text
Imports Goldammer

Namespace Online_PIDController
	Partial Public Class Form1
		Inherits Form
		Public Sub New()
			InitializeComponent()
		End Sub

		Private m_firstDev As MAIDevice = Nothing
		Private m_channel As MAIMeasurementChannelAD = Nothing
		Private m_bMeasurement As Boolean = False
		Private P As Double
		Private I As Double
		Private D As Double
		Private Nom As Double
		Private Gain As Double
		Private Min As Double
		Private Max As Double

		Private Sub GetPID()
			P = Convert.ToDouble(textBoxP.Text)
			I = Convert.ToDouble(textBoxI.Text)
			D = Convert.ToDouble(textBoxD.Text)

		End Sub
		Private Sub GetNom()
			Nom = Convert.ToDouble(textBoxNom.Text)
		End Sub
		Private Sub GetGainMinMax()
			Gain = Convert.ToDouble(textBoxGain.Text)
			Min = Convert.ToDouble(textBoxMin.Text)
			Max = Convert.ToDouble(textBoxMax.Text)

		End Sub

		Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
			m_firstDev = Goldammer.MAI.Devices(0)
			If m_firstDev Is Nothing Then
				MessageBox.Show("No Card found.")
				Close()
			End If
			If Not m_firstDev.HasSoftwareExtension(SWExtension.Online_PID) Then
				MessageBox.Show("This Card does not support PID.")
				Close()
			End If
			AddHandler m_firstDev.ADChannels.ProcessDataBuffers, AddressOf ADChannels_ProcessDataBuffers
			comboBox1.SelectedIndex = 0

		End Sub

		Private Sub ADChannels_ProcessDataBuffers(ByVal obj As Object, ByVal args As EventArgs)
			Try
				SetTextboxText("")

				Dim NofValues As UInteger = m_firstDev.ADChannels.GetNumberOfValues()
				Dim Values() As Double = Nothing
				For Each c As MAIMeasurementChannelAD In m_firstDev.ADChannels.GetMeasurementChannels()
					Values = c.ReadData(NofValues)
				Next c
				If Values Is Nothing Then
					Return
				End If
				Dim textboxtxt As String = ""
'INSTANT VB NOTE: The variable i was renamed since Visual Basic does not handle local variables named the same as class members well:
				For i_Renamed As Integer = 0 To 9
					If i_Renamed >= Values.Length Then
						Return
					End If
					textboxtxt &= Values(i_Renamed).ToString() & Environment.NewLine
				Next i_Renamed
				SetTextboxText(textboxtxt)

			Catch ex As Exception
				MessageBox.Show(ex.Message)
			End Try
		End Sub

		Private Sub SetTextboxText(ByVal AITextboxText As String)
			If InvokeRequired Then
				Dim invoker As New MethodInvoker(Function() AnonymousMethod1(AITextboxText))
				Invoke(invoker)
			Else
				textBox1.Text = AITextboxText
			End If
		End Sub
		
		Private Function AnonymousMethod1(ByVal AITextboxText As String) As Object
			textBox1.Text = AITextboxText
			Return Nothing
		End Function


		Private Sub button1_Click(ByVal sender As Object, ByVal e As EventArgs) Handles button1.Click
			If m_firstDev Is Nothing Then
				Return
			End If
			m_firstDev.ADChannels.StopMeasurement()
			m_firstDev.ADChannels.StopNotificationThread()
			m_firstDev.ClearAllChannelLists()
			buttonChangeNom.Enabled = False
			buttonChangePIDs.Enabled = False

			If Not m_bMeasurement Then
				Try
					GetPID()
					GetNom()
					GetGainMinMax()
					m_channel = m_firstDev.ADChannels(0).CreateMeasurementChannel(OversamplingMode.Disabled, GainFactor.Disabled, True)

					m_channel.Realtime.AddPIDController(P, I, D, CType(comboBox1.SelectedIndex, PIDControllerType), Gain, Nom, Min, Max, 0, 1000)

					m_firstDev.ADChannels.SetSampleRate(1000)
					m_firstDev.ADChannels.SetMeasurementBufferNotificationLevel(100)
					m_firstDev.ConfigMeasure()
					m_firstDev.ADChannels.StartNotificationThread()
					m_firstDev.ADChannels.StartMeasurement()
					m_bMeasurement = True
					button1.Text = "Stop"
					buttonChangeNom.Enabled = True
					buttonChangePIDs.Enabled = True
				Catch ex As Exception
					m_bMeasurement = False
					button1.Text = "Start"
					m_firstDev.ADChannels.StopMeasurement()
					m_firstDev.ADChannels.StopNotificationThread()
					m_firstDev.ClearAllChannelLists()
					MessageBox.Show(ex.Message)
				End Try
			Else
				m_bMeasurement = False
				button1.Text = "Start"

			End If


		End Sub

		Private Sub buttonChangeNom_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonChangeNom.Click
			If m_channel Is Nothing Then
				Return
			End If
			Try
				GetNom()
				TryCast(m_channel.Realtime(0), MAIRealtimeFunctionPID).ChangeNominalValue(Nom)
			Catch ex As Exception
				MessageBox.Show(ex.Message)
			End Try
		End Sub

		Private Sub buttonChangePIDs_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonChangePIDs.Click
			If m_channel Is Nothing Then
				Return
			End If
			Try
				GetPID()
				TryCast(m_channel.Realtime(0), MAIRealtimeFunctionPID).ChangePIDParameter(P,I,D)
			Catch ex As Exception
				MessageBox.Show(ex.Message)
			End Try
		End Sub





	End Class
End Namespace
